unit Example014LogMessages;

//*************************************************************************
//
// WARNING
//
//  The types and constants declared in this file were generated from
//  data read from the Example014LogMessages.elp module.
//  The contents of this file is recreated every time this module is
//  changed or even opened. All manual modifications will be lost.
//
//*************************************************************************

//*************************************************************************
//
//  This file contains constants and routines to write events into
//  system event log
//
//  USAGE
//
//  1. Register Example014LogMessages.dll with command
//     regsvr32 Example014LogMessages.dll
//     or use any other tool to call DllRegisterServer from Example014LogMessages.dll
//
//  2. Call SvLogMessage or SvLogData procedures to write events
//
//  3. You can see these events in the system event log.
//     Event log journal : System
//     Event source      : SvCom Events Example
//
//*************************************************************************

interface

uses
    SvCom_EventLog, SysUtils;

procedure SvLogMessage(Category: Integer; MessageId: Integer; MessageParts: array of String;
                        EventType: TNTEventType = etInformation);

procedure SvLogData(Category: Integer; MessageId: Integer; MessageParts: array of String;
                        Data: Pointer; DataSize: Integer;
                        EventType: TNTEventType = etInformation);


// Event categories

const ctgDisk = $01; // Disk notification category
const ctgMemory = $02; // Memory event category



// Event messages

const msgFileCreateError = $100; // File creation failed
const msgFileDeletionError = $101; // File deletion problem
const msgNoFreeMemory = $102; // Memory allocation problem


implementation

var _EventLog: TNTEventLog;

function EventLog: TNTEventLog;
begin
    if not Assigned(_EventLog) then
        _EventLog := TNTEventLog.Create('SvCom Events Example');
    result := _EventLog;
end;

procedure SvLogMessage(Category: Integer; MessageId: Integer;
                       MessageParts: array of String; EventType: TNTEventType);
begin
    EventLog.LogMessage(MessageParts, EventType, Category, MessageId);
end;


procedure SvLogData(Category: Integer; MessageId: Integer; MessageParts: array of String;
                    Data: Pointer; DataSize: Integer; EventType: TNTEventType);
begin
    EventLog.LogData(MessageParts, Data, DataSize, EventType, Category, MessageId);
end;



initialization

finalization
    FreeAndNil(_EventLog);
end.
